% solution of examples No. 1 to 3
   clc

   % vector (array) of nodal coordinates
    x = [0.0 0.1 0.2 0.3];

   % vector (array) of element conductivities
    lam = [2.0 2.0 2.0];

   % conectivity
    con = [1 2;
          2 3;
          3 4];

   % vector (array) of nodal code numbers
    cn = [0 1 2 0];

    % vector (array) of nodal Dirichlet b.c.
    d = [5.0 0 0 20.0];

    % vector (array) of nodal Neumann b.c.
    fn = [0 0 0 0];

    % vector (array) of nodal Newton b.c.
    fc = [0 0 0 0];

    % vector (array) of nodal transfer coefficients
    alpha = [0.0 0.0 0.0 0.0];

    % number of unknowns (DOF)
    n = 2;

    % number of nodes
    nn = 4;

    % number of elements
    nel = 3;

    k = zeros(n,n);
    xe = zeros(2,1);
    ke = zeros(2,2);
    de = zeros(2,1);
    ne = zeros(2,1);
    newe = zeros(2,1);
    f = zeros(n,1);

    for i=1:nel
        ia = con(i,1);
        ib = con(i,2);

        xe(1) = x(ia);
        xe(2) = x(ib);

        ke = conductivity_matrix (xe,lam(i));

        cne(1) = cn(ia);
        cne(2) = cn(ib);
        de(1) = d(ia);
        de(2) = d(ib);
        ne(1) = fn(ia);
        ne(2) = fn(ib);
        newe(1) = fc(ia)*alpha(ia);
        newe(2) = fc(ib)*alpha(ib);

        % conductivity matrix assembly
        k = localization(k, ke, cne);

        % right hand side
        f = right_hand_side_dirichlet (f, ke, de, cne);
        f = right_hand_side_neumann (f, ne, cne);
        f = right_hand_side_newton (f, che, cne);

        % contribution from Newton b.c.
        alpha_e(1) = alpha(ia);
        alpha_e(2) = alpha(ib);
        ke = conductivity_matrix_newton (alpha_e);
        % localization - conductivity matrix assembly
        k = localization(k, ke, cne);
    end
   k
   f

 % solution
 r = k\f;
 r


